(function () {
    "use strict";

    angular.module('core').controller('operacaoVendaController', controller);
    controller.$inject = ['$scope', '$timeout', 'operacaoVendaService', '$alert', 'lookupService','$q'];

    function controller($scope, $timeout, operacaoVendaService, $alert, lookupService, $q) {
        $scope.initializeLayout('Operações de Vendas');

        //[Inicializa objetos]
        $scope.state = {
            data: [],
            carregando: false,
            vazio: false,
            count: 0,
            filtro: {
                ativo: false,
                args: {
                    skip: 0,
                    take: 20
                }
            }
        };

        $scope.auxiliar = {
            tabelapreco: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllTabelaPreco({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            tipoclienteoperacao: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllTipoCliente({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },

        };


        $scope.popups = {
            add: {
                ativo: false,
                data: {},
                save: function (action) {
                    $scope.state.salvando = true;
                    operacaoVendaService
                        .save($scope.popups.add.data)
                        .then(
                        function (response) {
                            if (response.Status < 0) {
                                $scope.state.salvando = false;
                                $alert({ text: response.Message, title: $scope.Title });
                            } else {
                                $scope.state.salvando = false;
                                $scope.popups.add.ativo = false;
                                $scope.initialize();
                            }
                        },
                        function (_error) {
                            $scope.state.salvando = false;
                            $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        });
                },
                prepare: function () {
                    operacaoVendaService
                        .prepareNew()
                        .then(
                        function (response) {
                            if (response.Status < 0) {
                                $scope.tools.toastr.error(response.Message, 'Serviço');
                                $scope.popups.add.ativo = false;
                            } else {
                                $scope.popups.add.data = response.Data;
                                $timeout(function () { $('[ng-model*="popups.add.data."]').focus(); });
                            }
                        },
                        function (_error) {
                            $scope.popups.edit.ativo = false;
                            $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        });
                },
                toggle: function () {
                    $scope.popups.add.ativo = !$scope.popups.add.ativo;

                    if ($scope.popups.add.ativo) {
                        $scope.popups.add.prepare();
                    }

                }
            }
        };

        //[Inicializa funcões]
        $scope.initialize = function () {
            $scope.refresh();
        };

        $scope.getAll = function () {
            $scope.state.filtro.args.skip = 0;
            $scope.state.carregando = true;
            $scope.state.vazio = false;
            operacaoVendaService
                .getAll($scope.state.filtro.args)
                .then(
                function (response) {
                    if (response.Status < 0) {
                        $scope.tools.toastr.error(response.Message, 'Serviço');
                        console.error(response.Exception);
                    } else {
                        angular.copy(angular.fromJson(response.Data), $scope.state.data);
                    }
                    $scope.state.carregando = false;
                    $scope.state.vazio = ($scope.state.data == 0);
                },
                function (_error) {
                    $scope.state.carregando = false;
                    $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                    console.error(_error);
                }
                );
        };
        $scope.count = function () {
            operacaoVendaService
                .count($scope.state.filtro.args)
                .then(
                function (response) {
                    if (response.Status < 0) {
                        $scope.tools.toastr.error(response.Message, 'Serviço');
                        console.error(response.Exception);
                    } else {
                        $scope.state.count = response.Data;
                    }
                },
                function (_error) {
                    $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                    console.error(_error);
                }
                );
        };
        $scope.getMore = function () { 
            $scope.state.filtro.args.skip += $scope.state.filtro.args.take;
            operacaoVendaService
                .getAll($scope.state.filtro.args)
                .then(
                function (response) {
                    if (response.Status < 0) {
                        $scope.tools.toastr.error(response.Message, 'Serviço');
                        console.error(response.Exception);
                    } else {
                        $scope.state.data = $scope.state.data.concat(response.Data);
                    }
                },
                function (_error) {
                    $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                    console.error(_error);
                }
                );
        };
        $scope.refresh = function () {
            $scope.getAll();
            $scope.count();
            $scope.state.filtro.ativo = false;
        };

        $scope.clearFilter = function () {
            $scope.state.filtro.args = {
                chaves: '',
                filtro: null,
                filtroDe: null,
                filtroAte: null,
                filtroEm: null,
                sortExpression: '',
                skip: 0,
                take: 20
            };

            $scope.refresh();
        };
        $scope.toggleFilter = function () {
            $scope.state.filtro.ativo = !$scope.state.filtro.ativo;
        };

        /*Inicializa funções*/
        $scope.initialize();

    }

})();